sign <- function(l1, l2){
    len <- length(l1)
    for(r in 1:len){
        if(l2[r] < 0){
            l1[r] <- -1 * l1[r]
        }
    }
    l1
}

trim <- function (x) gsub("^\\s+|\\s+$", "", x)

input <- commandArgs(TRUE)[1]
outputFinal <- commandArgs(TRUE)[2]
index <- 4
options(digits=20)

if(file.info(input)$size ==0){
file.create(outputFinal)
print("Done!")
quit()
}

input.data.m <- read.table(input, sep="\t", header=T)


# Inferred networks preprocessing: creaction of the graph
input.data.df <- data.frame(v1=as.vector(input.data.m[,1]), v2=as.vector(input.data.m[,2]),
                            v3=as.vector(input.data.m[,3]),
                            v4=rep("-->", dim(input.data.m)[1]), v5=rep("--|", dim(input.data.m)[1]),
                            v6=as.vector(input.data.m[,4]),
                            v7=as.vector(input.data.m[,5]),
                            v8=as.vector(input.data.m[,6]))



dx_act <- input.data.df[as.vector(trim(input.data.df$v2)) == "-->",c("v1","v4", "v3", "v6", "v7", "v8") ]

sx_act <- input.data.df[as.vector(trim(input.data.df$v2)) == "<--",c("v3", "v4", "v1", "v6", "v7", "v8") ]

dx_inhib <- input.data.df[as.vector(trim(input.data.df$v2)) == "--|",c("v1", "v5",  "v3", "v6", "v7", "v8") ]

sx_inhib <- input.data.df[as.vector(trim(input.data.df$v2)) == "|--",c("v3", "v5",  "v1", "v6", "v7", "v8") ]


inferred.network <- rbind(as.matrix(dx_act), as.matrix(dx_inhib),  as.matrix(sx_act), as.matrix(sx_inhib))


if(length(inferred.network) == 0){
  file.create(outputFinal)
  quit()
}


l1 <- unlist(lapply(inferred.network[,1], function(x) gsub(",", "_", gsub(" ", "_", x))))
l2 <- unlist(lapply(inferred.network[,3], function(x) gsub(",", "_", gsub(" ", "_", x))))
l3 <- sign(as.numeric(inferred.network[,index]), as.numeric(inferred.network[,6]))

Mat2 <- cbind(l1,l2,l3)

write.table(Mat2, file=outputFinal, sep="\t", quote=FALSE, col.names=FALSE, row.names=FALSE)

("Done!")